GFX_VRAM equ 04008h
ATR_VRAM equ 05800h
BUFFER_VRAM equ 06000h

VRAM_LINES equ 08800h
NUM_LINES equ 192

BASESINE equ 08A00h
ROTODIFFS equ 08B00h

ROTO_WIDTH equ 128
ROTO_HEIGHT equ 48

org 08000h

    ld ix,VRAM_LINES
	call init_vram_lines
call gensine0
	main_loop:

	;xor a:;out (254),a   ;cpu_stop
    ei
	halt    ; vsync
    di
	;ld a,2:;out (254),a  ;cpu_start
    ;call copy_frame_buffer

    ld (sp_save),sp

    ld hl,VRAM_LINES + 96:ld sp,hl
	ld iy,ROTODIFFS

    ld hl,BUFFER_VRAM
    exx:ld hl,BUFFER_VRAM:exx
    ld a,ROTO_HEIGHT
	copy_y:
        pop de
        ld bc,ROTO_WIDTH / 8
        ldir
        exx
        pop de
        ld bc,ROTO_WIDTH / 8
        ldir
        exx
    dec a
	jr nz,copy_y

    ld sp,(sp_save)
; -------------------------

    ld hl,nframe
	ld c,(hl)
    inc (hl)

;	call provide_vectors
	; c = angle
	; computers are like porn
	; I want to study UFOs

	ld ixh,BASESINE / 256:ld ixl,c				;sin
	ld h,BASESINE / 256:ld a,c:sub 64:ld l,a 		;cos

;	cos,sin
	ld e,(hl):ld d,0:ex de,hl:ld (vec_horizontal),hl
	ld l,(ix):ld h,0:ld (vec_horizontal+2),hl

;	sin,-cos
	ld (vec_vertical),hl
	ex de,hl
	ld b,(hl):xor a:sub b
	ld e,a:ld d,255:ex de,hl:ld (vec_vertical+2),hl
; ----------------------

;	call calc_roto_diffs

	ld ix,ROTODIFFS
	ld hl,(vec_vertical):ex de,hl:ld hl,0
	exx:ld hl,(vec_vertical+2):ex de,hl:ld hl,0:ld bc,8:exx

	ld c,ROTO_HEIGHT
	roto_diffs_y:
		ld (ix),l:ld (ix+1),h:add hl,de
		exx:ld (ix+4),l:ld (ix+5),h:add hl,de:exx

		push hl
		ld hl,(vec_horizontal):ld (ix+2),l:ld (ix+3),h
		ld hl,(vec_horizontal+2):ld (ix+6),l:ld (ix+7),h
		pop hl

        exx:add ix,bc:exx

	dec c
	jr nz,roto_diffs_y

; ------------------------
	call calc_roto

    nop:nop
	jp main_loop

;copy_frame_buffer:

;ret

init_vram_lines:

    ld hl,GFX_VRAM
    ld bc,65536 - 2048 + 32
    ld de,2048 - 256
    xor a
    loop_vram_lines:
        inc a
        push af
            ld (ix),l:inc ix
            ld (ix),h:inc ix

            inc h

            and 63
                jr nz,noadd2
                add hl,de
                noadd2:

            and 7
                jr nz,noadd1
                add hl,bc
                noadd1:

        pop af
        cp NUM_LINES
    jr nz,loop_vram_lines
ret

; ----------------------------------

calc_roto:
;    di
    ;ld (sp_save),sp

    ;ld hl,VRAM_LINES + 96:;ld sp,hl
	;ld iy,ROTODIFFS

    ld bc,BUFFER_VRAM

    ld ixh,ROTO_HEIGHT
	roto_y:
		ld l,(iy):inc iyl:ld h,(iy):inc iyl
		ld e,(iy):inc iyl:ld d,(iy):inc iy

		exx
		ld l,(iy):inc iyl:ld h,(iy):inc iyl
		ld e,(iy):inc iyl:ld d,(iy):inc iy
		ld b,1
		exx

        ;pop bc
		ld ixl,ROTO_WIDTH/8
		roto_x:

			add hl,de:ld a,h
			exx:xor h:add hl,de
			and b:dec a
            and %11000000
            ld c,a
            exx

			add hl,de:ld a,h
			exx:xor h:add hl,de
			and b:dec a
			and %00110000
			or c:ld c,a
			exx

			add hl,de:ld a,h
			exx:xor h:add hl,de
			and b:dec a
			and %00001100
			or c:ld c,a
			exx

			add hl,de:ld a,h
			exx:xor h:add hl,de
			and b:dec a
			and %00000011
			or c
			exx

			;ld (bc),a:;inc b:;ld (bc),a:;dec b:;inc c
			ld (bc),a:inc bc

		dec ixl
		jr nz,roto_x
        ;pop bc
	dec ixh
	jr nz,roto_y

    ;ld sp,(sp_save)
;    ei
ret

;calc_roto_diffs:
;ret


;make_sines_base:
;	ld hl,basesinedata
;	ld bc,BASESINE
;	ld de,BASESINE+127
;	exx
;	ld bc,BASESINE+128
;	ld de,BASESINE+255
;	exx

;	ld ixl,64
;	loop_sine_make:
;		ld a,(hl):;inc hl
;		ld (bc),a:;inc c
;		ld (de),a:;dec e

;		exx
;		ld l,a:;ld a,255:;sub l
;		ld (bc),a:;inc c
;		ld (de),a:;dec e
;		exx
;	dec ixl
;	jr nz,loop_sine_make
;ret

LENGTH equ (5*256 + 64)
STRENGTH equ 32
CENTER equ 127

gensine0:
    exx:ld de,BASESINE:exx

    ld hl,CENTER*256:ld de,-LENGTH
    epi256:
        add hl,de:ex de,hl:add hl,bc:ex de,hl
        ld a,h
        push af

        cp CENTER
    jr nc,nodown

    ld bc,STRENGTH
    ld a,(change):or a
    jr nz,nochang1
        ld de,-LENGTH
        nochang1:
        inc a:ld (change),a
    jr noup

    nodown:
        ld bc,-STRENGTH
        ld a,(change):dec a
        jr nz,nochang2
        ld de,LENGTH
    nochang2:
        xor a:ld (change),a
    noup:

    pop af
    exx:srl a:ld (de),a:inc e:exx
    jr nz,epi256
ret

basesinedata:
;db 128,131,134,137,140,143,146,149,152,155,158,162,165,167,170,173
;db 176,179,182,185,188,190,193,196,198,201,203,206,208,211,213,215
;db 218,220,222,224,226,228,230,232,234,235,237,238,240,241,243,244
;db 245,246,248,249,250,250,251,252,253,253,254,254,254,255,255,255

sp_save EQU basesinedata + 64
;dw 0

vec_horizontal EQU basesinedata + 66
;dw 0,0
vec_vertical EQU basesinedata + 70
;dw 0,0

nframe EQU basesinedata + 74
;dw 0

change EQU basesinedata + 76

end 08000h
